<?php

define('MODX_API_MODE', true);
require dirname(dirname(dirname(dirname(dirname(__FILE__))))) . '/index.php';

$modx->getService('error','error.modError');
$modx->setLogLevel(modX::LOG_LEVEL_ERROR);
$modx->setLogTarget('FILE');

/* @var miniShop2 $miniShop2 */
$miniShop2 = $modx->getService('minishop2');
$miniShop2->loadCustomClasses('payment');

if (!class_exists('WC')) {exit( 'Error: could not load payment class "WC".');}
/* @var msPaymentInterface|PayPal $handler */
$handler = new WC($modx->newObject('msOrder'));


switch($_GET['action']){
	case 'success':
		$id = $modx->getOption('wc_success_page_id', null, 0);
		if($id>0) $modx->sendRedirect($modx->makeUrl($id));
		else $modx->sendRedirect($modx->getOption('site_url'));
	break;
	case 'cancel':
		$id = $modx->getOption('wc_fail_page_id', null, 0);
		if($id>0) $modx->sendRedirect($modx->makeUrl($id));
		else $modx->sendRedirect($modx->getOption('site_url'));
	break;
	default:
            
                $wc_api_password=$modx->getOption('wc_api_password');

                $headers=apache_request_headers();    
                $json_body=file_get_contents('php://input');
                $decoded_response=json_decode($json_body, true);
                
                $f=fopen('./log.txt', 'wb');
                fwrite($f, $json_body);
                fwrite($f, $headers);
                fclose($f);
                
                $hash_check=strtoupper(hash('sha256', $json_body.$wc_api_password));

                if($headers['WSignature']==$hash_check){ // hash checking

                        if($decoded_response['status']=='Created' || 
                           $decoded_response['status']=='Pending' || 
                           $decoded_response['status']=='Completed' ||
                           $decoded_response['status']=='Paid'){
                                
                                // some code to confirm payment
                                $order = $modx->getObject('msOrder', $decoded_response['invoiceId']);
                                $handler->receive($order);

                        }

                }else{

                        // some code to log invalid payments
                        if(!$order) $modx->log(modX::LOG_LEVEL_ERROR,  'Hash mismatch! '.$headers['WSignature'].' vs. '.$hash_check);

                }
                

}