<?php
if (!class_exists('msPaymentInterface')) {
	require_once dirname(dirname(dirname(__FILE__))) . '/model/minishop2/mspaymenthandler.class.php';
}

class WC extends msPaymentHandler implements msPaymentInterface {
	
	function __construct(xPDOObject $object) {
		
		$this->modx = & $object->xpdo;

		$this->config = array(
			'account' => $this->modx->getOption('wc_account'),
			'api_key' => $this->modx->getOption('wc_api_key'),
			'api_password' => $this->modx->getOption('wc_api_password')
		);
		
	}

	/* @inheritdoc} */
	public function send(msOrder $order) {
		
		if ($order->get('status') > 1) {
			return $this->error('ms2_err_status_wrong');
		}
		
		return $this->success('', array('msorder' => $order->get('id')));

	}


	/* @inheritdoc} */
	public function receive(msOrder $order) {
		
		/* @var miniShop2 $miniShop2 */
		$miniShop2 = $this->modx->getService('miniShop2');
                
                if(!$order) $modx->log(modX::LOG_LEVEL_ERROR, '[miniShop2] Could not retrieve order with id '.$decoded_response['data']['invoiceId']);
                
                // $this->config['api_key']
                        
                $headers=apache_request_headers();
                $json_body=file_get_contents('php://input');

                $hash_check=strtoupper(hash('sha256', $json_body.$this->config['api_password']));

                if($headers['WSignature']==$hash_check){ // hash checking
                    
                        $decoded_response=json_decode($json_body, true);
                    
                        $miniShop2->changeOrderStatus($order->get('id'), 2); // Setting status "paid"

                }else{

                        // some code to log bad hash requests
                        $this->modx->log(modX::LOG_LEVEL_ERROR, "[WC] bad hash; WSignature: ".$headers['WSignature']."; hash: $hash_check");

                }
		
		return true;
	}

	/**
	 * Returns a direct link for continue payment process of existing order
	 *
	 * @param msOrder $order
	 *
	 * @return string
	 */
	public function getPaymentLink(msOrder $order) {
		
		return $this->success('', array('msorder' => $order->get('id')));
		
	}

}